--LED Display
--A MaxScript by Oormi Creations
--http://oormi.in
--oormicreations@gmail.com
--See help document for details

clearlistener()

try (destroydialog SevenSegRollout)
catch ()


digit = #()
ledx = 80
ledy = 20
ledz = 20
ledtaper = 10
ledgap = 5

oncolor = color 255 0 0
offcolor = color 64 50 50
ledcolor = color 190 150 150
initvalue = 5

ledx1 = 80
ledy1 = 20
ledz1 = 20
ledtaper1 = 10
ledgap1 = 5

customseq = #()
onduration = 30
delay = 5
animloop = 1
startat = 0
rcount = 10

--define digits with ON segmets
digitpat = #()
digitpat[1] = #(5,7)
digitpat[2] = #(1,2,3,5,6)
digitpat[3] = #(1,2,3,5,7)
digitpat[4] = #(1,4,5,7)
digitpat[5] = #(1,2,3,4,7)
digitpat[6] = #(1,2,3,4,6,7)
digitpat[7] = #(2,5,7)
digitpat[8] = #(1,2,3,4,5,6,7)
digitpat[9] = #(1,2,3,4,5,7)
digitpat[10] = #(2,3,4,5,6,7)
digitpat[11] = #()


fn setdigit dig =
(
	if dig==0 then dig = 10
	if dig<0 then dig = 11
	if dig==undefined then dig = 11
	
	for n=1 to 7 do digit[n].mat.diffuse = offcolor
	for n=1 to digitpat[dig].count do digit[digitpat[dig][n]].mat.diffuse = oncolor
)

fn createssd =
(
	digit[1] = box length:ledy width:ledx height:ledz lengthsegs:2 name:(uniquename "Seg")
	converttopoly digit[1]
	
	polyop.setvertselection digit[1] #{3,9}
	move digit[1].selectedVerts [-ledtaper,0,0]
	polyop.setvertselection digit[1] #{4,10}
	move digit[1].selectedVerts [ledtaper,0,0]
	
	d=ledx+2*ledtaper+ledgap
	digit[2] = instance digit[1]
	move digit[2] [0,d,0]
	digit[3] = instance digit[1]
	move digit[3] [0,-d,0]
	
	d=d/2
	digit[4] = instance digit[1]
	move digit[4] [-d,d,0]
	rotate digit[4] (angleaxis -90 [0,0,1])
	
	digit[5] = instance digit[1]
	move digit[5] [d,d,0]
	rotate digit[5] (angleaxis -90 [0,0,1])
	
	digit[6] = instance digit[1]
	move digit[6] [-d,-d,0]
	rotate digit[6] (angleaxis -90 [0,0,1])
	
	digit[7] = instance digit[1]
	move digit[7] [d,-d,0]
	rotate digit[7] (angleaxis -90 [0,0,1])

	for d in digit do 
	(
		d.mat = Standard()
		d.wirecolor = ledcolor
	)
	setdigit initvalue
)

fn getcustomseq txt =
(
	if txt.count<1 then txt = "0,1,0,1,0,1,0,1"
	customseq = filterstring txt ","
	for n=1 to customseq.count do 
	(
		customseq[n] = customseq[n] as integer
		if customseq[n] == undefined then customseq[n] = -1
		if (customseq[n]<-1) then customseq[n] = 0
	)
)

fn animatessd type playit =
(
	seq = #(10,1,2,3,4,5,6,7,8,9)
	if type == 2 then seq = #(9,8,7,6,5,4,3,2,1,10)
	if type == 3 then for r=1 to rcount do seq[r] = random 1 10
	if type == 4 then seq = customseq

	t1 = startat
	with animate on 
	(
		at time t1 setdigit seq[seq.count]
		at time (t1+delay) setdigit seq[1]
	)
	
	t1 = onduration 
	for loop=1 to animloop do
	(
		for n=1 to seq.count do
		(
			with animate on
			(
				at time t1 setdigit seq[n]
				next = n+1
				if n+1>seq.count then next = 1
				at time (t1+delay) setdigit seq[next]
			)
			t1 = t1 + onduration
		)
	)
	
	animationRange = interval (startat+delay) (onduration*seq.count*animloop+delay+startat)
	if playit then playanimation()
)


rollout SevenSegRollout "Seven Segment LED 1.0" width:200 height:750
(
	button btn1 "Create 7 Segment Display" pos:[20,10] width:160 height:30
	groupBox grp1 "Segment Shape" pos:[10,40] width:180 height:190
	spinner spn1 "Length" pos:[20,60] width:150 height:16 range:[0,10000,80]
	spinner spn2 "Width  " pos:[20,90] width:150 height:16 range:[0,10000,20]
	spinner spn3 "Height " pos:[20,120] width:150 height:16 range:[0,10000,20]
	spinner spn4 "Taper  " pos:[20,150] width:150 height:16 range:[0,10000,10]
	spinner spn6 "Gap    " pos:[20,180] width:150 height:16 range:[0,10000,5]
	spinner spn5 "Value   " pos:[20,210] width:150 height:16 range:[-1,11,5] type:#integer scale:1
	button btn2 "New Pattern from Selection" pos:[20,235] width:160 height:30
	groupBox grp2 "Segment Material" pos:[10,270] width:180 height:120
	colorPicker cp1 "On Color   " pos:[20,300] width:150 height:20 color:(color 255 0 0) fieldWidth:60
	colorPicker cp2 "Off Color   " pos:[20,330] width:150 height:20 color:(color 64 50 50) fieldWidth:60
	colorPicker cp3 "Wire Color" pos:[20,360] width:150 height:20 color:(color 190 150 150) fieldWidth:60
	groupBox grp3 "Animation" pos:[10,400] width:180 height:280
	checkbox chk1 "Animate" pos:[20,420] width:60 height:20
	checkbox chk2 "Play Animation" pos:[87,420] width:90 height:20
	radioButtons rdo1 "Sequence :   " pos:[20,440] width:100 height:78 labels:#("Count Up", "Count Down", "Random (Enter count below)", "Enter Sequence below (CSV)") columns:1
	editText edt1 "" pos:[20,520] width:160 height:16
	spinner spn7 "On Duration (frames)" pos:[60,550] width:120 height:16 range:[2,10000,30] type:#integer scale:1
	spinner spn8 "Transition (frames)" pos:[60,580] width:120 height:16 range:[1,10000,5] type:#integer scale:1
	spinner spn9 "Loops                  " pos:[60,610] width:120 height:16 range:[1,10000,1] type:#integer scale:1
	spinner spn10 "Start At (frame)  " pos:[60,640] width:120 height:16 range:[-10000,10000,0] type:#integer scale:1
	groupBox grp4 "Get more scripts :" pos:[10,680] width:100 height:60
	groupBox grp5 "Help" pos:[120,680] width:70 height:60
	hyperlink hlink1 "Oormi Creations" pos:[20,710] address:"http://oormi.in/software-01.html" color:orange
	hyperlink hlink2 "RTFM" pos:[140,710] address:"http://oormi.in/software/ledhelp-01.html" color:orange
	
	fn updateanim =
	(
		if digit[1]==undefined then return 0
		if isdeleted digit[1] then return 0
		getcustomseq edt1.text
		rcount = edt1.text as integer
		if (rcount==undefined) or (rcount<1) then rcount = 10
		onduration = spn7.value
		delay = spn8.value
		animloop = spn9.value
		startat = spn10.value
		
		for d in digit do if d.mat.diffuse.keys!=undefined then deletekeys d.mat.diffuse.keys #allKeys	
		if chk1.checked then animatessd rdo1.state chk2.checked
	)
	
	on btn1 pressed  do
	(
		digit = #()
		ledx = spn1.value
		ledy = spn2.value
		ledz = spn3.value
		ledtaper = spn4.value
		ledgap = spn6.value
		initvalue = spn5.value
		
		oncolor = cp1.color
		offcolor = cp2.color
		ledcolor = cp3.color

		createssd()
		updateanim()		
	)
	
	on btn2 pressed  do
	(
		if digit[1]==undefined then return 0
		if isdeleted digit[1] then return 0
		if selection.count<1 then
		(
			messagebox "Please Select a Segment"
			return 0
		)
		nextpat = digitpat.count+1
		digitpat[nextpat] = #()
		for n=1 to 7 do
		(
			if digit[n].isselected then append digitpat[nextpat] n
		)
		format "digpat[%]=%\n" nextpat digitpat[nextpat]
		setdigit nextpat
		spn5.range = [-1,nextpat,nextpat]
	)
	
	on spn1 changed val do
	(
		if digit[1]==undefined then return 0
		if isdeleted digit[1] then return 0
		newx = (ledx1-val)/2
		polyop.movevert digit[1]  #{1, 3, 5, 7, 9, 11} [newx,0,0]
		polyop.movevert digit[1]  #{2, 4, 6, 8, 10, 12} [-newx,0,0]
		move digit[2] [0,-2*newx,0]
		move digit[3] [0,2*newx,0]
		move digit[4] [newx,-newx,0]
		move digit[5] [-newx,-newx,0]
		move digit[6] [newx,newx,0]
		move digit[7] [-newx,newx,0]
		ledx1 = val
		redrawviews()
	)
	
	on spn6 changed val do
	(
		if digit[1]==undefined then return 0
		if isdeleted digit[1] then return 0
		dgap = (ledgap1-val)/2
		move digit[2] [0,-2*dgap,0]
		move digit[3] [0,2*dgap,0]
		move digit[4] [dgap,-dgap,0]
		move digit[5] [-dgap,-dgap,0]
		move digit[6] [dgap,dgap,0]
		move digit[7] [-dgap,dgap,0]
		ledgap1 = val
		redrawviews()
	)
	
	on spn2 changed val do
	(
		if digit[1]==undefined then return 0
		if isdeleted digit[1] then return 0
		newy = (ledy1-val)/2
		polyop.movevert digit[1]  #{1,2,7,8} [0,newy,0]
		polyop.movevert digit[1]  #{5,6,11,12} [0,-newy,0]
		ledy1 = val
		redrawviews()
	)

	on spn3 changed val do
	(
		if digit[1]==undefined then return 0
		if isdeleted digit[1] then return 0
		newz = (ledz1-val)/2
		polyop.movevert digit[1]  #{1..6} [0,0,newz]
		polyop.movevert digit[1]  #{7..12} [0,0,-newz]
		ledz1 = val
		redrawviews()
	)

	on spn4 changed val do
	(
		if digit[1]==undefined then return 0
		if isdeleted digit[1] then return 0
		newx = (ledtaper1-val)
		polyop.movevert digit[1]  #{3,9} [newx,0,0]
		polyop.movevert digit[1]  #{4,10} [-newx,0,0]
		move digit[2] [0,-2*newx,0]
		move digit[3] [0,2*newx,0]
		move digit[4] [newx,-newx,0]
		move digit[5] [-newx,-newx,0]
		move digit[6] [newx,newx,0]
		move digit[7] [-newx,newx,0]
		ledtaper1 = val
		redrawviews()
	)

	on cp1 changed col do
	(
		if digit[1]==undefined then return 0
		if isdeleted digit[1] then return 0
		oncolor = col
		if chk1.checked then animatessd rdo1.state chk2.checked
 		else setdigit spn5.value
	)

	on cp2 changed col do
	(
		if digit[1]==undefined then return 0
		if isdeleted digit[1] then return 0
		offcolor = col
		if chk1.checked then animatessd rdo1.state chk2.checked
 		else setdigit spn5.value
	)

	on cp3 changed col do 
	(
		if digit[1]==undefined then return 0
		if isdeleted digit[1] then return 0
		digit.wirecolor = col
	)
	
	on spn5 changed val do 
	(
		if digit[1]==undefined then return 0
		if isdeleted digit[1] then return 0
		setdigit spn5.value
	)
	
	on spn7 changed val do updateanim()
	on spn8 changed val do updateanim()
	on spn9 changed val do updateanim()
	on spn10 changed val do updateanim()
	on rdo1 changed state do updateanim()
	on chk1 changed state do updateanim()
)

createdialog SevenSegRollout